'use strict';

var VError = require('verror');
var isPromise = require('is-promise');
var isFunction = require('lodash.isfunction');
var isPlainObject = require('lodash.isplainobject');

var utils = {
  isPromise,

  isFunction,

  isTask(obj) {
    return isPlainObject(obj) && isFunction(obj.run) && isFunction(obj.pipe);
  },

  isFlow(obj) {
    return isPlainObject(obj) && isFunction(obj.run) && isFunction(obj.asTask);
  },

  buildTaskError(cause, taskID, flowOpts) {
    return new VError({
      cause,
      name: 'TaskError',
      constructorOpt: utils.buildTaskError,
      info: {
        taskID,
        flowName: flowOpts.name,
        flowMode: flowOpts.mode
      }
    }, `task "${taskID}" in flow{${flowOpts.name}}:${flowOpts.mode} has failed`);
  }
};

module.exports = utils;